/*-
 * Copyright (C)2000, 2001, 2002 @BABOLO http://www.links.ru/~babolo/
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHORS ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 *  OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#ifndef lint
static const char copyright[] = "\
@(#)Copyright (C)2000, 2001, 2002 @BABOLO http://www.links.ru/~babolo/\n\
@(#)All rights reserved.\n";
static const char rcsid[] = "$Id: pass4.c,v 1.2 2002/10/12 06:07:14 babolo Exp $";
#endif /* not lint */

#include <sys/types.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include "getCGIparm.h"
#define BUFL 512
u_char *pname, buff[BUFL];

/**********************************
 * positions to begin of new line *
 **********************************/
void
scaml(FILE *ine)
{   while(!feof(ine) && fgetc(ine) != '\n');
}

/*******************************************
 * skip out strings with white space begin *
 *******************************************/
void
scamb(FILE *ine)
{   int c;

    while(!feof(ine))
    {   c = fgetc(ine);
        if  (c == ' ' || c == '\t') scaml(ine);
        else
        {   if  (!feof(ine)) ungetc(c, ine);
            break;
}   }   }

/****************
 * inputs flass *
 ****************/
u_int32_t
scamg(FILE *ine)
{   int c = 0;
    u_int32_t i = 0, n = 0;

    if  (pname) free(pname);
    pname = NULL;
    if  (feof(ine));
    else if ((c = fgetc(ine)) == '-')
    {   while(!feof(ine) && (c = fgetc(ine)) == 'x') i = ((i << 1) | 1) & ERRMASK;
        if  (!feof(ine) && c == 'n')
        {   while(!feof(ine) && (c = fgetc(ine)) == ' ');
            pname = malloc(BUFL); n = 0;
            if  (!feof(ine)) ungetc(c, ine);
            while(!feof(ine) && (c = fgetc(ine)) != ' ') pname[n++] = c;
            pname[n++] = '\0';
        }
        while(!feof(ine) && c == ' ') c = fgetc(ine);
        if  (!feof(ine)) ungetc(c, ine);
    }else ungetc(c, ine);
    return(i);
}

/*****************
 * inputs tofind *
 *****************/
int
scamp(FILE *ine)
{   int c = 0, p = 0;

    while(p < BUFL && !feof(ine) && c != '\n')
    {   c = fgetc(ine);
        if  (feof(ine));
        else if (c != '\n') buff[p++] = c;
    }
    if  (c != '\n') scaml(ine);
    buff[p] = '\0';
    return(p);
}

void
pass4( u_int32_t flags
     , u_char *tofind
     , u_char *toname
     , u_char *errmsg
     , u_char *errfile
     , u_char *errform
     )
{   int i;
    FILE *ine;
    u_int32_t f;

    if  (flags & VERB)
        fprintf( stderr
               , "P4 flags=%06X, tofind=%s~, toname=%s~, errmsg=%s~, errfile=%s~, errform=%s~\n"
               , flags
               , tofind ? tofind : empty
               , toname ? toname : empty
               , errmsg ? errmsg : empty
               , errfile ? errfile : empty
               , errform ? errform : empty
               );
    if  (errmsg) fprintf(stderr, "%s", errmsg);
    else if  (errfile)
    {   ine = fopen(errfile, "r");
        if  (ine)
        {   for (;;)
            {   i = fgetc(ine);
                if  (feof(ine) || ferror(ine)) break;
                fputc(i, stderr);
            }
        fclose(ine);
        }
    }else if  (errform)
    {   ine = fopen(errform, "r");
        while(ine && !feof(ine))
        {   scamb(ine);
            f = scamg(ine);
            if  ((i = scamp(ine)) && buff[--i] == '*') f |= OPEN;
            if  (flags & VERB)
                fprintf(stderr, "pname =%s~,%s~\n", pname ? pname : empty, i ? buff : empty);
            if  (  (f & ERRMASK) <= (flags & ERRMASK)
                && ((!toname && !pname) || (toname && pname && strcmp(pname, toname) == 0))
                && !((f & OPEN) ? strncmp(tofind, buff, i) : strcmp(tofind, buff))
                )
            {   int c = fgetc(ine);
                while(!feof(ine) && c != ' ' && c != '\t')
                {   ungetc(c, ine);
                    scaml(ine);
                    c = fgetc(ine);
                }
                while(!feof(ine) && (c == ' ' || c == '\t'))
                {   while(!feof(ine) && c != '\n')
                    {   if  (~flags & OTST) fputc(c, stderr);
                        c = fgetc(ine);
                    }
                    if  (!feof(ine))
                    {   if  (~flags & OTST) fputc(c, stderr);
                        c = fgetc(ine);
                }   }
                fclose(ine);
                ine = NULL;
}   }   }   }
